Loading...
Searching...
No Matches
elastix::MultiResolutionRegistration< TElastix > Class Template Reference
Components » Registrations

`#include <elxMultiResolutionRegistration.h>`

## Detailed Description

template<class TElastix>
class elastix::MultiResolutionRegistration< TElastix >

A registration framework based on the itk::MultiResolutionImageRegistrationMethod.

This MultiResolutionRegistration gives a framework for registration with a multi-resolution approach.

The parameters used in this class are:

Parameters

  Registration: Select this registration framework as follows:
  (Registration "MultiResolutionRegistration")

  NumberOfResolutions: the number of resolutions used.
  example: (NumberOfResolutions 4)
  The default is 3.

Definition at line 45 of file elxMultiResolutionRegistration.h.

Inheritance diagram for elastix::MultiResolutionRegistration< TElastix >:
[legend]

## Public Types

using | ConstPointer = itk::SmartPointer<const Self>
using | ITKBaseType = typename Superclass2::ITKBaseType
using | Pointer = itk::SmartPointer<Self>
using | RegistrationType = typename Superclass2::RegistrationType
using | Self = MultiResolutionRegistration
using | Superclass1 = typename RegistrationBase<TElastix>::ITKBaseType
using | Superclass2 = RegistrationBase<TElastix>
using | UseMaskErosionArrayType
Public Types inherited from itk::MultiResolutionImageRegistrationMethod2< FixedImageType, MovingImageType >
using | ConstPointer
using | DataObjectPointer
using | FixedImageConstPointer
using | FixedImagePyramidPointer
using | FixedImagePyramidType
using | FixedImageRegionPyramidType
using | FixedImageRegionType
using | FixedImageType
using | InterpolatorPointer
using | InterpolatorType
using | MetricPointer
using | MetricType
using | MovingImageConstPointer
using | MovingImagePyramidPointer
using | MovingImagePyramidType
using | MovingImageType
using | OptimizerType
using | ParametersType
using | Pointer
using | Self
using | Superclass
using | TransformOutputConstPointer
using | TransformOutputPointer
using | TransformOutputType
using | TransformPointer
using | TransformType
Public Types inherited from elastix::RegistrationBase< TElastix >
using | ElastixType
using | FixedImageType = typename ElastixType::FixedImageType
using | ITKBaseType = itk::MultiResolutionImageRegistrationMethod2<FixedImageType, MovingImageType>
using | MovingImageType = typename ElastixType::MovingImageType
using | RegistrationType
using | Self = RegistrationBase
using | Superclass = BaseComponentSE<TElastix>
using | UseMaskErosionArrayType = std::vector<bool>
Public Types inherited from elastix::BaseComponentSE< TElastix >
using | ElastixType = TElastix
using | RegistrationType = typename ElastixType::RegistrationBaseType
using | Self = BaseComponentSE
using | Superclass = BaseComponent

## Public Member Functions

void | BeforeEachResolution () override
void | BeforeRegistration () override
| elxClassNameMacro ("MultiResolutionRegistration")
virtual const char * | GetClassName () const
| ITK_DISALLOW_COPY_AND_MOVE (MultiResolutionRegistration)
| itkStaticConstMacro (FixedImageDimension, unsigned int, Superclass2::FixedImageDimension)
| itkStaticConstMacro (MovingImageDimension, unsigned int, Superclass2::MovingImageDimension)
Public Member Functions inherited from itk::MultiResolutionImageRegistrationMethod2< FixedImageType, MovingImageType >
virtual unsigned long | GetCurrentLevel () const
virtual const FixedImageType * | GetFixedImage ()
virtual const FixedImageRegionType & | GetFixedImageRegion ()
virtual const ParametersType & | GetInitialTransformParameters ()
virtual const ParametersType & | GetInitialTransformParametersOfNextLevel ()
virtual const ParametersType & | GetLastTransformParameters ()
virtual const MovingImageType * | GetMovingImage ()
ModifiedTimeType | GetMTime () const override
virtual unsigned long | GetNumberOfLevels () const
const TransformOutputType * | GetOutput () const
| ITK_DISALLOW_COPY_AND_MOVE (MultiResolutionImageRegistrationMethod2)
| itkGetModifiableObjectMacro (FixedImagePyramid, FixedImagePyramidType)
| itkGetModifiableObjectMacro (Interpolator, InterpolatorType)
| itkGetModifiableObjectMacro (Metric, MetricType)
| itkGetModifiableObjectMacro (MovingImagePyramid, MovingImagePyramidType)
| itkGetModifiableObjectMacro (Optimizer, OptimizerType)
| itkGetModifiableObjectMacro (Transform, TransformType)
DataObjectPointer | MakeOutput (ProcessObject::DataObjectPointerArraySizeType idx) override
virtual void | SetFixedImage (const FixedImageType *_arg)
virtual void | SetFixedImagePyramid (FixedImagePyramidType *_arg)
virtual void | SetFixedImageRegion (FixedImageRegionType _arg)
virtual void | SetInitialTransformParameters (ParametersType _arg)
virtual void | SetInitialTransformParametersOfNextLevel (ParametersType _arg)
virtual void | SetInterpolator (InterpolatorType *_arg)
virtual void | SetMetric (MetricType *_arg)
virtual void | SetMovingImage (const MovingImageType *_arg)
virtual void | SetMovingImagePyramid (MovingImagePyramidType *_arg)
virtual void | SetNumberOfLevels (unsigned long _arg)
virtual void | SetOptimizer (OptimizerType *_arg)
virtual void | SetTransform (TransformType *_arg)
virtual void | StartRegistration ()
virtual void | StopRegistration ()
Public Member Functions inherited from elastix::RegistrationBase< TElastix >
ITKBaseType * | GetAsITKBaseType ()
const ITKBaseType * | GetAsITKBaseType () const
| ITK_DISALLOW_COPY_AND_MOVE (RegistrationBase)
| itkStaticConstMacro (FixedImageDimension, unsigned int, FixedImageType::ImageDimension)
| itkStaticConstMacro (MovingImageDimension, unsigned int, MovingImageType::ImageDimension)
virtual bool | ReadMaskParameters (UseMaskErosionArrayType &useMaskErosionArray, const unsigned int nrOfMasks, const std::string &whichMask, const unsigned int level) const
Public Member Functions inherited from elastix::BaseComponentSE< TElastix >
void | AddTargetCellToIterationInfo (const char *const name)
const Configuration * | GetConfiguration () const
ElastixType * | GetElastix () const
auto & | GetIterationInfoAt (const char *const name)
RegistrationType * | GetRegistration () const
| ITK_DISALLOW_COPY_AND_MOVE (BaseComponentSE)
void | RemoveTargetCellFromIterationInfo (const char *const name)
void | SetConfiguration (const Configuration *_arg)
void | SetElastix (ElastixType *_arg)
Public Member Functions inherited from elastix::BaseComponent
virtual void | AfterEachIteration ()
virtual void | AfterEachIterationBase ()
virtual void | AfterEachResolution ()
virtual void | AfterEachResolutionBase ()
virtual void | AfterRegistration ()
virtual void | AfterRegistrationBase ()
virtual int | BeforeAll ()
virtual int | BeforeAllBase ()
virtual void | BeforeEachResolutionBase ()
virtual void | BeforeRegistrationBase ()
virtual const char * | elxGetClassName () const
const char * | GetComponentLabel () const
| ITK_DISALLOW_COPY_AND_MOVE (BaseComponent)
| itkTypeMacroNoParent (BaseComponent)
void | SetComponentLabel (const char *label, unsigned int idx)

## Static Public Member Functions

static Pointer | New ()
Static Public Member Functions inherited from itk::MultiResolutionImageRegistrationMethod2< FixedImageType, MovingImageType >
static Pointer | New ()
Static Public Member Functions inherited from elastix::BaseComponent
template<typename TBaseComponent>
static auto | AsITKBaseType (TBaseComponent *const baseComponent) -> decltype(baseComponent->GetAsITKBaseType())
static void | InitializeElastixExecutable ()
static bool | IsElastixLibrary ()

## Protected Types

using | FixedMaskImagePointer
using | FixedMaskImageType
using | FixedMaskSpatialObjectPointer
using | FixedMaskSpatialObjectType
using | MaskPixelType
using | MovingMaskImagePointer
using | MovingMaskImageType
using | MovingMaskSpatialObjectPointer
using | MovingMaskSpatialObjectType
Protected Types inherited from elastix::RegistrationBase< TElastix >
using | FixedImagePyramidType = typename ITKBaseType::FixedImagePyramidType
using | FixedMaskErodeFilterPointer = typename FixedMaskErodeFilterType::Pointer
using | FixedMaskErodeFilterType = itk::ErodeMaskImageFilter<FixedMaskImageType>
using | FixedMaskImagePointer = typename FixedMaskImageType::Pointer
using | FixedMaskImageType = typename ElastixType::FixedMaskType
using | FixedMaskSpatialObjectPointer = typename FixedMaskSpatialObjectType::Pointer
using | FixedMaskSpatialObjectType = itk::ImageMaskSpatialObject<Self::FixedImageDimension>
using | MaskPixelType = typename ElastixType::MaskPixelType
using | MovingImagePyramidType = typename ITKBaseType::MovingImagePyramidType
using | MovingMaskErodeFilterPointer = typename MovingMaskErodeFilterType::Pointer
using | MovingMaskErodeFilterType = itk::ErodeMaskImageFilter<MovingMaskImageType>
using | MovingMaskImagePointer = typename MovingMaskImageType::Pointer
using | MovingMaskImageType = typename ElastixType::MovingMaskType
using | MovingMaskSpatialObjectPointer = typename MovingMaskSpatialObjectType::Pointer
using | MovingMaskSpatialObjectType = itk::ImageMaskSpatialObject<Self::MovingImageDimension>

## Protected Member Functions

| MultiResolutionRegistration ()=default
virtual void | SetComponents ()
void | UpdateMasks (unsigned int level)
| ~MultiResolutionRegistration () override=default
Protected Member Functions inherited from itk::MultiResolutionImageRegistrationMethod2< FixedImageType, MovingImageType >
void | GenerateData () override
virtual void | Initialize ()
| MultiResolutionImageRegistrationMethod2 ()
virtual void | PreparePyramids ()
void | PrintSelf (std::ostream &os, Indent indent) const override
virtual void | SetCurrentLevel (unsigned long _arg)
| ~MultiResolutionImageRegistrationMethod2 () override=default
Protected Member Functions inherited from elastix::RegistrationBase< TElastix >
FixedMaskSpatialObjectPointer | GenerateFixedMaskSpatialObject (const FixedMaskImageType *maskImage, bool useMaskErosion, const FixedImagePyramidType *pyramid, unsigned int level) const
MovingMaskSpatialObjectPointer | GenerateMovingMaskSpatialObject (const MovingMaskImageType *maskImage, bool useMaskErosion, const MovingImagePyramidType *pyramid, unsigned int level) const
| RegistrationBase ()=default
| ~RegistrationBase () override=default
Protected Member Functions inherited from elastix::BaseComponentSE< TElastix >
| BaseComponentSE ()=default
| ~BaseComponentSE () override=default
Protected Member Functions inherited from elastix::BaseComponent
| BaseComponent ()=default
virtual | ~BaseComponent ()=default

## Private Attributes

| elxOverrideGetSelfMacro

## Additional Inherited Members

Protected Attributes inherited from itk::MultiResolutionImageRegistrationMethod2< FixedImageType, MovingImageType >
ParametersType | m_LastTransformParameters
bool | m_Stop
Protected Attributes inherited from elastix::BaseComponentSE< TElastix >
Configuration::ConstPointer | m_Configuration {}
itk::WeakPointer< TElastix > | m_Elastix {}
RegistrationType * | m_Registration {}

## Member Typedef Documentation

## ConstPointer

template<class TElastix>

using elastix::MultiResolutionRegistration< TElastix >::ConstPointer = itk::SmartPointer<const Self>

Definition at line 57 of file elxMultiResolutionRegistration.h.

## FixedMaskImagePointer

template<class TElastix>

using elastix::RegistrationBase< TElastix >::FixedMaskImagePointer

protected

Definition at line 158 of file elxRegistrationBase.h.

## FixedMaskImageType

template<class TElastix>

using elastix::RegistrationBase< TElastix >::FixedMaskImageType

protected

Definition at line 156 of file elxRegistrationBase.h.

## FixedMaskSpatialObjectPointer

template<class TElastix>

using elastix::RegistrationBase< TElastix >::FixedMaskSpatialObjectPointer

protected

Definition at line 162 of file elxRegistrationBase.h.

## FixedMaskSpatialObjectType

template<class TElastix>

using elastix::RegistrationBase< TElastix >::FixedMaskSpatialObjectType

protected

Definition at line 160 of file elxRegistrationBase.h.

## ITKBaseType

template<class TElastix>

using elastix::MultiResolutionRegistration< TElastix >::ITKBaseType = typename Superclass2::ITKBaseType

Definition at line 113 of file elxMultiResolutionRegistration.h.

## MaskPixelType

template<class TElastix>

using elastix::RegistrationBase< TElastix >::MaskPixelType

protected

Typedef's for mask support.

Definition at line 155 of file elxRegistrationBase.h.

## MovingMaskImagePointer

template<class TElastix>

using elastix::RegistrationBase< TElastix >::MovingMaskImagePointer

protected

Definition at line 159 of file elxRegistrationBase.h.

## MovingMaskImageType

template<class TElastix>

using elastix::RegistrationBase< TElastix >::MovingMaskImageType

protected

Definition at line 157 of file elxRegistrationBase.h.

## MovingMaskSpatialObjectPointer

template<class TElastix>

using elastix::RegistrationBase< TElastix >::MovingMaskSpatialObjectPointer

protected

Definition at line 163 of file elxRegistrationBase.h.

## MovingMaskSpatialObjectType

template<class TElastix>

using elastix::RegistrationBase< TElastix >::MovingMaskSpatialObjectType

protected

Definition at line 161 of file elxRegistrationBase.h.

## Pointer

template<class TElastix>

using elastix::MultiResolutionRegistration< TElastix >::Pointer = itk::SmartPointer<Self>

Definition at line 56 of file elxMultiResolutionRegistration.h.

## RegistrationType

template<class TElastix>

using elastix::MultiResolutionRegistration< TElastix >::RegistrationType = typename Superclass2::RegistrationType

Definition at line 112 of file elxMultiResolutionRegistration.h.

## Self

template<class TElastix>

using elastix::MultiResolutionRegistration< TElastix >::Self = MultiResolutionRegistration

Standard ITK.

Definition at line 53 of file elxMultiResolutionRegistration.h.

## Superclass1

template<class TElastix>

using elastix::MultiResolutionRegistration< TElastix >::Superclass1 = typename RegistrationBase<TElastix>::ITKBaseType

Definition at line 54 of file elxMultiResolutionRegistration.h.

## Superclass2

template<class TElastix>

using elastix::MultiResolutionRegistration< TElastix >::Superclass2 = RegistrationBase<TElastix>

Definition at line 55 of file elxMultiResolutionRegistration.h.

## UseMaskErosionArrayType

template<class TElastix>

using elastix::RegistrationBase< TElastix >::UseMaskErosionArrayType

Typedef for mask erosion options

Definition at line 104 of file elxRegistrationBase.h.

## Constructor & Destructor Documentation

## MultiResolutionRegistration()

template<class TElastix>

elastix::MultiResolutionRegistration< TElastix >::MultiResolutionRegistration | ( |  | ) |

protected default

The constructor.

## ~MultiResolutionRegistration()

template<class TElastix>

elastix::MultiResolutionRegistration< TElastix >::~MultiResolutionRegistration | ( |  | ) |

override protected default

The destructor.

## Member Function Documentation

## BeforeEachResolution()

template<class TElastix>

void elastix::MultiResolutionRegistration< TElastix >::BeforeEachResolution | ( |  | ) |

override virtual

Execute stuff before each resolution:

- Update masks with an erosion.

Reimplemented from elastix::BaseComponent.

## BeforeRegistration()

template<class TElastix>

void elastix::MultiResolutionRegistration< TElastix >::BeforeRegistration | ( |  | ) |

override virtual

Execute stuff before the actual registration:

- Connect all components to the registration framework.
- Set the number of resolution levels.
- Set the fixed image region.

Reimplemented from elastix::BaseComponent.

## elxClassNameMacro()

template<class TElastix>

elastix::MultiResolutionRegistration< TElastix >::elxClassNameMacro | ( | "MultiResolutionRegistration< TElastix >" |  | ) |

Name of this class. Use this name in the parameter file to select this specific registration framework.
example: (Registration "MultiResolutionRegistration")

## GetClassName()

template<class TElastix>

virtual const char * elastix::MultiResolutionRegistration< TElastix >::GetClassName | ( |  | ) | const

virtual

Run-time type information (and related methods).

Reimplemented from itk::MultiResolutionImageRegistrationMethod2< FixedImageType, MovingImageType >.

## ITK_DISALLOW_COPY_AND_MOVE()

template<class TElastix>

elastix::MultiResolutionRegistration< TElastix >::ITK_DISALLOW_COPY_AND_MOVE | ( | MultiResolutionRegistration< TElastix > |  | ) |

## itkStaticConstMacro() [1/2]

template<class TElastix>

elastix::MultiResolutionRegistration< TElastix >::itkStaticConstMacro | ( | FixedImageDimension | ,
|  | unsigned int | ,
|  | Superclass2::FixedImageDimension | )

Get the dimension of the fixed image.

## itkStaticConstMacro() [2/2]

template<class TElastix>

elastix::MultiResolutionRegistration< TElastix >::itkStaticConstMacro | ( | MovingImageDimension | ,
|  | unsigned int | ,
|  | Superclass2::MovingImageDimension | )

Get the dimension of the moving image.

## New()

template<class TElastix>

Pointer elastix::MultiResolutionRegistration< TElastix >::New | ( |  | ) |

static

Method for creation through the object factory.

## SetComponents()

template<class TElastix>

virtual void elastix::MultiResolutionRegistration< TElastix >::SetComponents | ( |  | ) |

protected virtual

Read the components from m_Elastix and set them in the Registration class.

## UpdateMasks()

template<class TElastix>

void elastix::MultiResolutionRegistration< TElastix >::UpdateMasks | ( | unsigned int | level | ) |

protected

Function to update fixed and moving masks.

## Field Documentation

## elxOverrideGetSelfMacro

template<class TElastix>

elastix::MultiResolutionRegistration< TElastix >::elxOverrideGetSelfMacro

private

Definition at line 159 of file elxMultiResolutionRegistration.h.

Generated on 1768596610 for elastix by 1.15.0 |